Index: src/sas/sasgui/perspectives/fitting/fitting.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting.py	(revision 7673ecd9d5adcefdfa1fc6a6d1ff0649f8e63bc8)
+++ src/sas/sasgui/perspectives/fitting/fitting.py	(revision ca4d9854c75a5344e770dec25221dfeb5a270915)
@@ -313,5 +313,5 @@
         """
         event_id = event.GetId()
-        self.update_custom_combo()        
+        self.update_custom_combo()
 
     def update_custom_combo(self):
@@ -342,6 +342,5 @@
                                 page.formfactorbox.SetLabel(current_val)
         except:
-            pass
-
+            logging.error("update_custom_combo: %s", sys.exc_value)
 
     def set_edit_menu(self, owner):
@@ -1666,45 +1665,93 @@
         wx.PostEvent(self.parent, StatusEvent(status=msg, type="update"))
 
+    def create_theory_1D(self, x, y, page_id, model, data, state,
+                         data_description, data_id, dy=None):
+        """
+            Create a theory object associate with an existing Data1D
+            and add it to the data manager.
+            @param x: x-values of the data
+            @param y: y_values of the data
+            @param page_id: fit page ID
+            @param model: model used for fitting
+            @param data: Data1D object to create the theory for
+            @param state: model state
+            @param data_description: title to use in the data manager
+            @param data_id: unique data ID
+        """
+        new_plot = Data1D(x=x, y=y)
+        if dy is None:
+            new_plot.is_data = False
+            new_plot.dy = numpy.zeros(len(y))
+            # If this is a theory curve, pick the proper symbol to make it a curve
+            new_plot.symbol = GUIFRAME_ID.CURVE_SYMBOL_NUM
+        else:
+            new_plot.is_data = True
+            new_plot.dy = dy
+        new_plot.interactive = True
+        new_plot.dx = None
+        new_plot.dxl = None
+        new_plot.dxw = None
+        _yaxis, _yunit = data.get_yaxis()
+        _xaxis, _xunit = data.get_xaxis()
+        new_plot.title = data.name
+        new_plot.group_id = data.group_id
+        if new_plot.group_id == None:
+            new_plot.group_id = data.group_id
+        new_plot.id = data_id
+        # Find if this theory was already plotted and replace that plot given
+        # the same id
+        self.page_finder[page_id].get_theory_data(fid=data.id)
+
+        if data.is_data:
+            data_name = str(data.name)
+        else:
+            data_name = str(model.__class__.__name__)
+
+        new_plot.name = data_description + " [" + data_name + "]"
+        new_plot.xaxis(_xaxis, _xunit)
+        new_plot.yaxis(_yaxis, _yunit)
+        self.page_finder[page_id].set_theory_data(data=new_plot,
+                                                  fid=data.id)
+        self.parent.update_theory(data_id=data.id, theory=new_plot,
+                                   state=state)
+        return new_plot
+
     def _complete1D(self, x, y, page_id, elapsed, index, model,
                     weight=None, fid=None,
                     toggle_mode_on=False, state=None,
                     data=None, update_chisqr=True,
-                    source='model', plot_result=True):
-        """
-        Complete plotting 1D data
+                    source='model', plot_result=True,
+                    unsmeared_model=None, unsmeared_data=None,
+                    unsmeared_error=None, sq_model=None, pq_model=None):
+        """
+            Complete plotting 1D data
+            @param unsmeared_model: fit model, without smearing
+            @param unsmeared_data: data, rescaled to unsmeared model
+            @param unsmeared_error: data error, rescaled to unsmeared model
         """
         try:
             numpy.nan_to_num(y)
-
-            new_plot = Data1D(x=x, y=y)
-            new_plot.is_data = False
-            new_plot.dy = numpy.zeros(len(y))
-            new_plot.symbol = GUIFRAME_ID.CURVE_SYMBOL_NUM
-            _yaxis, _yunit = data.get_yaxis()
-            _xaxis, _xunit = data.get_xaxis()
-            new_plot.title = data.name
-
-            new_plot.group_id = data.group_id
-            if new_plot.group_id == None:
-                new_plot.group_id = data.group_id
-            new_plot.id = str(page_id) + " " + data.name
-            #if new_plot.id in self.color_dict:
-            #    new_plot.custom_color = self.color_dict[new_plot.id]
-            #find if this theory was already plotted and replace that plot given
-            #the same id
-            self.page_finder[page_id].get_theory_data(fid=data.id)
-
-            if data.is_data:
-                data_name = str(data.name)
-            else:
-                data_name = str(model.__class__.__name__)
-
-            new_plot.name = model.name + " [" + data_name + "]"
-            new_plot.xaxis(_xaxis, _xunit)
-            new_plot.yaxis(_yaxis, _yunit)
-            self.page_finder[page_id].set_theory_data(data=new_plot,
-                                                      fid=data.id)
-            self.parent.update_theory(data_id=data.id, theory=new_plot,
-                                       state=state)
+            new_plot = self.create_theory_1D(x, y, page_id, model, data, state,
+                                             data_description=model.name,
+                                             data_id=str(page_id) + " " + data.name)
+            if unsmeared_model is not None:
+                self.create_theory_1D(x, unsmeared_model, page_id, model, data, state,
+                                      data_description=model.name + " unsmeared",
+                                      data_id=str(page_id) + " " + data.name + " unsmeared")
+
+                self.create_theory_1D(x, unsmeared_data, page_id, model, data, state,
+                                      data_description="Data unsmeared",
+                                      data_id="Data  " + data.name + " unsmeared",
+                                      dy=unsmeared_error)
+                
+            if sq_model is not None and pq_model is not None:
+                self.create_theory_1D(x, sq_model, page_id, model, data, state,
+                                      data_description=model.name + " S(q)",
+                                      data_id=str(page_id) + " " + data.name + " S(q)")
+                self.create_theory_1D(x, pq_model, page_id, model, data, state,
+                                      data_description=model.name + " P(q)",
+                                      data_id=str(page_id) + " " + data.name + " P(q)")
+
+
             current_pg = self.fit_panel.get_page_by_id(page_id)
             title = new_plot.title
Index: src/sas/sasgui/perspectives/fitting/model_thread.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/model_thread.py	(revision 934ce6493af6e904cf20f2500ef522b42192adfd)
+++ src/sas/sasgui/perspectives/fitting/model_thread.py	(revision ca4d9854c75a5344e770dec25221dfeb5a270915)
@@ -7,4 +7,5 @@
 import math
 from sas.sascalc.data_util.calcthread import CalcThread
+from sas.sascalc.fit.MultiplicationModel import MultiplicationModel
 
 class Calc2D(CalcThread):
@@ -166,4 +167,8 @@
         index = (self.qmin <= self.data.x) & (self.data.x <= self.qmax)
 
+        # If we use a smearer, also return the unsmeared model
+        unsmeared_output = None
+        unsmeared_data = None
+        unsmeared_error = None
         ##smearer the ouput of the plot
         if self.smearer is not None:
@@ -171,8 +176,30 @@
                                                              self.qmax)
             mask = self.data.x[first_bin:last_bin+1]
-            output[first_bin:last_bin+1] = self.model.evalDistribution(mask)
-            output = self.smearer(output, first_bin, last_bin)
+            unsmeared_output = numpy.zeros((len(self.data.x)))
+            unsmeared_output[first_bin:last_bin+1] = self.model.evalDistribution(mask)
+            output = self.smearer(unsmeared_output, first_bin, last_bin)
+            
+            # Rescale data to unsmeared model
+            unsmeared_data = numpy.zeros((len(self.data.x)))
+            unsmeared_error = numpy.zeros((len(self.data.x)))
+            unsmeared_data[first_bin:last_bin+1] = self.data.y[first_bin:last_bin+1]\
+                                                    * unsmeared_output[first_bin:last_bin+1]\
+                                                    / output[first_bin:last_bin+1]
+            unsmeared_error[first_bin:last_bin+1] = self.data.dy[first_bin:last_bin+1]\
+                                                    * unsmeared_output[first_bin:last_bin+1]\
+                                                    / output[first_bin:last_bin+1]
+            unsmeared_output=unsmeared_output[index]
+            unsmeared_data=unsmeared_data[index]
+            unsmeared_error=unsmeared_error
         else:
             output[index] = self.model.evalDistribution(self.data.x[index])
+
+        sq_model = None
+        pq_model = None
+        if isinstance(self.model, MultiplicationModel):
+            sq_model = numpy.zeros((len(self.data.x)))
+            pq_model = numpy.zeros((len(self.data.x)))
+            sq_model[index] = self.model.s_model.evalDistribution(self.data.x[index])
+            pq_model[index] = self.model.p_model.evalDistribution(self.data.x[index])
 
         elapsed = time.time() - self.starttime
@@ -187,5 +214,10 @@
                       data=self.data,
                       update_chisqr=self.update_chisqr,
-                      source=self.source)
+                      source=self.source,
+                      unsmeared_model=unsmeared_output,
+                      unsmeared_data=unsmeared_data,
+                      unsmeared_error=unsmeared_error,
+                      pq_model=pq_model,
+                      sq_model=sq_model)
 
     def results(self):
Index: src/sas/sasgui/perspectives/fitting/pagestate.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/pagestate.py	(revision 7673ecd9d5adcefdfa1fc6a6d1ff0649f8e63bc8)
+++ src/sas/sasgui/perspectives/fitting/pagestate.py	(revision 6c382da7a67e14f0ad75317f0696ce771b802d39)
@@ -24,4 +24,6 @@
 from xml.dom.minidom import parseString
 from lxml import etree
+
+import sasmodels.weights
 
 import sas.sascalc.dataloader
@@ -474,5 +476,6 @@
                 value = content[1]
             except Exception:
-                logging.error(traceback.format_exc())
+                msg = "Report string expected 'name: value' but got %r"%line
+                logging.error(msg)
             if name.count("State created"):
                 repo_time = "" + value
@@ -516,5 +519,6 @@
                         title_name = HEADER % title
                 except Exception:
-                    logging.error(traceback.format_exc())
+                    msg = "While parsing 'data: ...'\n"
+                    logging.error(msg + traceback.format_exc())
             if name == "model name ":
                 try:
@@ -531,5 +535,6 @@
                     q_range = CENTRE % q_name
                 except Exception:
-                    logging.error(traceback.format_exc())
+                    msg = "While parsing 'Plotting Range: ...'\n"
+                    logging.error(msg + traceback.format_exc())
         paramval = ""
         for lines in param_string.split(":"):
@@ -711,5 +716,4 @@
         # For self.values ={ disp_param_name: [vals,...],...}
         # and for self.weights ={ disp_param_name: [weights,...],...}
-        value_list = {}
         for item in LIST_OF_MODEL_ATTRIBUTES:
             element = newdoc.createElement(item[0])
@@ -725,9 +729,8 @@
 
         # Create doc for the dictionary of self._disp_obj_dic
-        for item in DISPERSION_LIST:
-            element = newdoc.createElement(item[0])
-            value_list = getattr(self, item[1])
-            for key, val in value_list.iteritems():
-                value = repr(val)
+        for tagname, varname, tagtype in DISPERSION_LIST:
+            element = newdoc.createElement(tagname)
+            value_list = getattr(self, varname)
+            for key, value in value_list.iteritems():
                 sub_element = newdoc.createElement(key)
                 sub_element.setAttribute('name', str(key))
@@ -847,32 +850,30 @@
                 # Recover _disp_obj_dict from xml file
                 self._disp_obj_dict = {}
-                for item in DISPERSION_LIST:
-                    # Get node
-                    node = get_content("ns:%s" % item[0], entry)
+                for tagname, varname, tagtype in DISPERSION_LIST:
+                    node = get_content("ns:%s" % tagname, entry)
                     for attr in node:
-                        name = str(attr.get('name'))
-                        val = attr.get('value')
-                        value = val.split(" instance")[0]
-                        disp_name = value.split("<")[1]
-                        try:
-                            # Try to recover disp_model object from strings
-                            com = "from sas.models.dispersion_models "
-                            com += "import %s as disp"
-                            com_name = disp_name.split(".")[3]
-                            exec com % com_name
-                            disp_model = disp()
-                            attribute = getattr(self, item[1])
-                            attribute[name] = com_name
-                        except Exception:
-                            logging.error(traceback.format_exc())
+                        parameter = str(attr.get('name'))
+                        value = attr.get('value')
+                        if value.startswith("<"):
+                            try:
+                                # <path.to.NamedDistribution object/instance...>
+                                cls_name = value[1:].split()[0].split('.')[-1]
+                                cls = getattr(sasmodels.weights, cls_name)
+                                value = cls.type
+                            except Exception:
+                                logging.error("unable to load distribution %r for %s"
+                                              % (value, parameter))
+                                continue
+                        _disp_obj_dict = getattr(self, varname)
+                        _disp_obj_dict[parameter] = value
 
                 # get self.values and self.weights dic. if exists
-                for item in LIST_OF_MODEL_ATTRIBUTES:
-                    node = get_content("ns:%s" % item[0], entry)
+                for tagname, varname in LIST_OF_MODEL_ATTRIBUTES:
+                    node = get_content("ns:%s" % tagname, entry)
                     dic = {}
                     value_list = []
                     for par in node:
                         name = par.get('name')
-                        values = par.text.split('\n')
+                        values = par.text.split()
                         # Get lines only with numbers
                         for line in values:
@@ -882,7 +883,9 @@
                             except Exception:
                                 # pass if line is empty (it happens)
-                                logging.error(traceback.format_exc())
+                                msg = ("Error reading %r from %s %s\n"
+                                       % (line, tagname, name))
+                                logging.error(msg + traceback.format_exc())
                         dic[name] = numpy.array(value_list)
-                    setattr(self, item[1], dic)
+                    setattr(self, varname, dic)
 
     def set_plot_state(self, figs, canvases):
@@ -1231,5 +1234,6 @@
 
         except:
-            logging.info("XML document does not contain fitting information.\n %s" % sys.exc_value)
+            logging.info("XML document does not contain fitting information.\n"
+                         + traceback.format_exc())
 
         return state
@@ -1569,5 +1573,8 @@
                     if output[ind].run_name is not None\
                         and len(output[ind].run_name) != 0:
-                        name = output[ind].run_name
+                        if isinstance(output[ind].run_name, dict):
+                            name = output[ind].run_name.keys()[0]
+                        else:
+                            name = output[ind].run_name
                     else:
                         name = original_fname
Index: src/sas/sasgui/perspectives/invariant/invariant_panel.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision c12f9b402755d93d47add995041991b04f9687b4)
+++ src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 654e8e066dda6b98c221cad28e05fa6996e7fc11)
@@ -250,7 +250,7 @@
 
             num = self.state.saved_state['state_num']
-            if num > 0:
+            if int(num) > 0:
                 self._set_undo_flag(True)
-            if num < len(state.state_list) - 1:
+            if int(num) < len(state.state_list) - 1:
                 self._set_redo_flag(True)
 
@@ -830,8 +830,13 @@
         """
         try:
-            attr = getattr(self, key)
+            if key in ['compute_num', 'file', 'is_time_machine', 'state_num']:
+                return
+            else:
+                attr = getattr(self, key)
             if attr.__class__.__name__ == "StaticText":
                 return
-            if type(value) is not bool:
+            if value in ["True", "False", True, False]:
+                value = bool(value)
+            else:
                 value = str(value)
             attr.SetValue(value)
@@ -1860,5 +1865,5 @@
                                    (self.button_calculate, 0,
                                     wx.RIGHT | wx.TOP | wx.BOTTOM, 10),
-                                   (self.button_help, 0, 
+                                   (self.button_help, 0,
                                     wx.RIGHT | wx.TOP | wx.BOTTOM, 10),])
     def _do_layout(self):
@@ -1882,8 +1887,8 @@
         self.SetSizer(self.main_sizer)
         self.SetAutoLayout(True)
-        
+
     def on_help(self, event):
         """
-        Bring up the Invariant Documentation whenever the HELP button is 
+        Bring up the Invariant Documentation whenever the HELP button is
         clicked.
 
Index: src/sas/sasgui/perspectives/invariant/invariant_state.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_state.py	(revision c10d9d6c8667422d3db329ac32d0528a6cce3fc6)
+++ src/sas/sasgui/perspectives/invariant/invariant_state.py	(revision cb93b405a73e2c9eef55d1ac6f2bbcff2b0b9d6d)
@@ -426,5 +426,5 @@
                         if input_field is not None:
                             temp_state[item] = val
-                            self.state_list[ind] = temp_state
+                            self.state_list[str(ind)] = temp_state
 
             # Parse current state (ie, saved_state)
@@ -790,3 +790,2 @@
             doc = state.toXML(datainfo.name, doc=doc, entry_node=sasentry)
         return doc
-
Index: test/sasdataloader/test/utest_ascii.py
===================================================================
--- test/sasdataloader/test/utest_ascii.py	(revision b699768550de9d4b35b087234ec1d2a461922bab)
+++ test/sasdataloader/test/utest_ascii.py	(revision 7d94915074e1688fc87991152ae32ccfce9987f4)
@@ -94,7 +94,5 @@
         f = self.loader.load("ascii_test_6.txt")
         # The length of the data is 5
-        self.assertEqual(len(f.x), 4)
-        self.assertEqual(f.x[0],0.013534)
-        self.assertEqual(f.x[3],0.022254)
+        self.assertEqual(f, None)
         
 if __name__ == '__main__':
